/*****************************************************************************
deley library :
this library use for make deley in your program for use it:
0-copy 	delay.c and delay.h to your project folder
1-define crystal value in your main prgram ( in main.c) ->	 #define crystal	18432000
2-include "delay.c"  to your main prgram ( in main.c)  ->#include "delay.c"
3-use bottom  function for make delay:
  delay_us(x);
  delay_ms(x);
  delay_s(x) ;                     
4-maximom Error in all function is +- 0 to 3% 
mimimum delay in this library is 10 us 
******************************************************************************
technical detail:                             
*****************************************************************************
Developed by 1nafar whitout any warranty
use, copy, modify, and distribute this software is freely granted
*****************************************************************************/

//include  standard function use in delay.c
#include "delay.h"
 //if (crystal not define in main prgram this eeror has been show:
#ifndef crystal
   #error crystal value not define, define it by '#define crystal x'(x is crystal value in hertz)statement  Before #include "delay.h"
#endif


volatile char cont_value_for_delay_lib ;
//calculation	MCK ( main CPU clock ):
//if use pll  MCK=(((crystal / pll_divider) * (pll_multiplier+1) )/ prescaler)
//if dont use pll  MCK=(crystal / prescaler)
//this library not work if Slow Clock is selected , this work only whit Main Clock & PLL Clock
unsigned int get_MCK_value_4_delay_lib (void)  
{
	switch ( AT91C_BASE_PMC->PMC_MCKR& AT91C_PMC_CSS) {		
		case AT91C_PMC_CSS_MAIN_CLK: // Main clock is selected
		return crystal / (1 << ((AT91C_BASE_PMC->PMC_MCKR & AT91C_PMC_PRES) >> 2));
		case AT91C_PMC_CSS_PLL_CLK: // PLLB clock is selected
		return (((crystal 
		 / (AT91C_BASE_CKGR->CKGR_PLLR  & AT91C_CKGR_DIV))   //pll_divider
		  * (((AT91C_BASE_CKGR->CKGR_PLLR  & AT91C_CKGR_MUL) >> 16)+1) )  //pll_multiplier
		  / (1 << ((AT91C_BASE_PMC->PMC_MCKR & AT91C_PMC_PRES) >> 2)));	 //prescaler			
	}	 
   return 0;
}
// function for make  delay in us
//for generate 1 us time we need calculation how long take to cpu Compietion one line of program 
//(baray ejad takhir bayad cpu ro be  kar dege  mashghol konim ke  behtarin kar  shemordan adad hast:
//time to Compietion one line of program=1/ MCK ->MCK valeu get from get_MCK_value_4_delay_lib (void)
// for take 1us time CPU shuld cont. 0 to 1us/(1/MCK)
//example :if mck =48MHz -> i= 48 -> for creation 1us deley CPU must Compietion 48 line of program 
void delay_us(unsigned int us)
{  
	unsigned int i;	
	unsigned int cont;
	signed int cont_final=cont_value_for_delay_lib;
	us=us/10;
//	us=us/10;
		if(cont_value_for_delay_lib==0){
		float MCK_value_4_delay_lib;
MCK_value_4_delay_lib=get_MCK_value_4_delay_lib()*.000001;
cont_value_for_delay_lib=(MCK_value_4_delay_lib*2)-2	;
//printf("cont_value_for_delay_lib%d\n",cont_value_for_delay_lib);
cont_final=cont_value_for_delay_lib;
	}
	for(i=0;i<us;i++)	  
	for(cont=0;cont<cont_final;cont++) ;	
}

// function for make  delay in ms
void delay_ms(unsigned int ms)
{
	unsigned int i;
	for(i=0;i<ms;i++)
	{
//	printf("a is: %d\n",i);
		delay_us(999);
	}
}

// function for make  delay in us
void delay_s(unsigned int s)
{
	unsigned int i;
	for(i=0;i<s;i++)
	{
		delay_ms(999);
	}
}
