   //                  In The Name Of GOD 
 
 
  /* AT91SAMT7X256 Register definitions */
  #include <AT91SAM7X256.H> 
  /* Delay Functions */
  #define F_CPU 18432000
  #include "delay.h"

  /* Declare LCD Rotation */
  #define LANDSCAPE
  /* LCD Pin Configuration */
  #define TFTLCD_DATAPORT_B             
  #define TFTLCD_DATAPORT_OFFSET      0
  #define TFTLCD_CONTROLPORT_B          
  #define TFTLCD_RST                  16
  #define TFTLCD_RS                   18
  #define TFTLCD_CS                   17
  #define TFTLCD_WR                   19
  #define TFTLCD_RD                   20                             
  /* LCD Functions */
  #include "picture.h"
  #include "tftlcd_functions.c"


  int main(void) 
    {			 
	delay_ms(100);
	/* LCD Initialization */
	tftlcd_init();

    #ifdef LANDSCAPE
    tftlcd_write_pic(0,0,picture);
	delay_ms(5000);

	tftlcd_draw_line(5,5,180,120,RED);
	tftlcd_draw_line(10,5,185,120,GREEN);
	tftlcd_draw_line(15,5,190,120,BLUE);

	tftlcd_draw_rectangle(160,20,250,120,0,YELLOW);
	tftlcd_draw_rectangle(165,25,245,115,0,PURPLE);
	tftlcd_draw_rectangle(170,30,240,110,1,BLUE);

	tftlcd_draw_circle(70,150,50,0,GREEN);
	tftlcd_draw_circle(90,150,50,1,PURPLE);

	tftlcd_gotoxy(20,12);
	tftlcd_putsf("...:::HELLO:::...",RED,WHITE,0);
	tftlcd_gotoxy(2,9);
	tftlcd_putsf("without Transparent",GREEN,WHITE,0);
	tftlcd_gotoxy(2,10);
	tftlcd_putsf("Transparent Mode",BLUE,WHITE,1);

	delay_ms(10000);


	while(1)
		{
		tftlcd_draw_rectangle(0,0,319,239,1,RED);
		delay_ms(1000);
		tftlcd_draw_rectangle(0,0,319,239,1,GREEN);
		delay_ms(1000);
		tftlcd_draw_rectangle(0,0,319,239,1,BLUE);
		delay_ms(1000);
		};
    #endif


    #ifdef PORTRAIT
    tftlcd_write_pic(0,0,picture);
	delay_ms(50000);

	tftlcd_draw_line(5,5,180,120,RED);
	tftlcd_draw_line(10,5,185,120,GREEN);
	tftlcd_draw_line(15,5,190,120,BLUE);

	tftlcd_draw_rectangle(160,20,200,120,0,YELLOW);
	tftlcd_draw_rectangle(165,25,205,115,0,PURPLE);
	tftlcd_draw_rectangle(170,30,205,110,1,BLUE);

	tftlcd_draw_circle(70,150,50,0,GREEN);
	tftlcd_draw_circle(90,150,50,1,PURPLE);

	tftlcd_gotoxy(3,3);
	tftlcd_putsf("...:::HELLO:::...",RED,WHITE,0);
	tftlcd_gotoxy(3,4);
	tftlcd_putsf("without Transparent",GREEN,WHITE,0);
	tftlcd_gotoxy(3,6);
	tftlcd_putsf("Transparent Mode",BLUE,WHITE,1);

	delay_ms(10000);


	while(1)
		{
		tftlcd_draw_rectangle(0,0,239,319,1,RED);
		delay_ms(1000);
		tftlcd_draw_rectangle(0,0,239,319,1,GREEN);
		delay_ms(1000);
		tftlcd_draw_rectangle(0,0,239,319,1,BLUE);
		delay_ms(1000);
		};
    #endif

	}
