#include <AT91SAM7X256.H>   
#include "lib_AT91SAM7X256.h" 
 #define LCD_PORT_B
 #define LCD_RS 8
#define LCD_E 10
#define LCD_DB4 12
#define LCD_DB5 13
#define LCD_DB6 14
#define LCD_DB7 15
#include "lcd.h" 
int i, n,time,step,LEDSpeed= 1000000; 
const int led_mask[] = {AT91C_PIO_PB23, AT91C_PIO_PB24, AT91C_PIO_PB25, AT91C_PIO_PB26};
void left_to_right(void) ;
void right_to_left(void);
 void change_speed_roll (void) ;
 void wait (void) ;
int main (void) {
lcd_init();
    lcd_clear();
  AT91F_PIO_CfgOutput(AT91C_BASE_PIOB, 0x07F80000);
  AT91F_PMC_EnablePeriphClock(AT91C_BASE_PMC, 1 << AT91C_ID_PIOA); 
  AT91F_PIO_CfgInput(AT91C_BASE_PIOA, 0x78000000);	  	  
 // AT91F_PIO_CfgPullup(AT91C_BASE_PIOA,0x78000000);	 
	while(1){	  
lcd_gotoxy(1,1);
lcd_putsf("push Sw1-sw4 to ");
lcd_gotoxy(2,1);
lcd_putsf("set speed & roll");
  AT91F_PIO_SetOutput(AT91C_BASE_PIOB, 0x07F80000);
wait();
  	  AT91F_PIO_ClearOutput(AT91C_BASE_PIOB, 0x07F80000);
wait();
}}
void wait (void) {
  for (n = 0; n <LEDSpeed; n++);
  change_speed_roll();
}
   void change_speed_roll (void) {
  if ((AT91F_PIO_GetInput(AT91C_BASE_PIOA) & AT91C_PIO_PA27) == 0) 
   LEDSpeed =LEDSpeed-20000;
  if ((AT91F_PIO_GetInput(AT91C_BASE_PIOA) &AT91C_PIO_PA28) == 0) 
       LEDSpeed=LEDSpeed+20000; 
if ((LEDSpeed=LEDSpeed)>=4000000) 
       LEDSpeed=50000;
	   if ((LEDSpeed=LEDSpeed)<50000) 
       LEDSpeed=4000000;  
  if ((AT91F_PIO_GetInput(AT91C_BASE_PIOA) & AT91C_PIO_PA29) == 0)    //chake porta.30
right_to_left();
if ((AT91F_PIO_GetInput(AT91C_BASE_PIOA) & AT91C_PIO_PA30) == 0)   //chake porta.30
left_to_right();
}
void right_to_left(void) {
  lcd_clear();
 AT91F_PIO_SetOutput(AT91C_BASE_PIOB, 0x07F80000);
 while(1){
    for (i = 0; i <4 ; i++) {
lcd_gotoxy(1,1);
lcd_putsf("ROLL: R to L");
lcd_gotoxy(2,1);
lcd_putsf("T/S:");
lcd_gotoxy(2,5);
time=LEDSpeed/10000;
lcd_puts(time);
 lcd_gotoxy(2,8);
lcd_putsf(" step:");
++step;
lcd_gotoxy(2,14);
lcd_puts(step);


      AT91F_PIO_ClearOutput(AT91C_BASE_PIOB, led_mask[i]);
      wait();
      AT91F_PIO_SetOutput  (AT91C_BASE_PIOB, led_mask[i]);
      wait();
	  }}}
void left_to_right(void) {
lcd_clear();
 AT91F_PIO_SetOutput(AT91C_BASE_PIOB, 0x07F80000);
while(1){
    for (i =3; i >= 0; i--) {
	lcd_gotoxy(1,1);
lcd_putsf("ROLL: L to R");
lcd_gotoxy(2,1);
lcd_putsf("T/S:");
lcd_gotoxy(2,5);
time=LEDSpeed/10000;
lcd_puts(time);
 lcd_gotoxy(2,8);
lcd_putsf(" step:");
++step;
lcd_gotoxy(2,14);
lcd_puts(step);
      AT91F_PIO_ClearOutput(AT91C_BASE_PIOB, led_mask[i]);
      wait();
      AT91F_PIO_SetOutput  (AT91C_BASE_PIOB, led_mask[i]);
      wait();
	  }}  }
	  


