//-------------------------------------------------------------------------------------------------
// KS0108 driver library  for AT91sam7S/X microcontrollers
// www.farzadsw.ir
//-------------------------------------------------------------------------------------------------

//#include <at91sam7s64.h>
#include "at91sam7x256.h"
#include "delay.h"
 #define GLCD_DATAPORT_B 
 #define GLCD_D0		8					 
#define GLCD_RS	    1
#define GLCD_RW	    2
#define GLCD_EN	    3
#define GLCD_CS1	5
#define GLCD_CS2	4
#define GLCD_CS3    16
#include "ks0108.h"

int main(void)
{
 char i,x;
GLCD_Initialize();
GLCD_ClearScreen();
GLCD_GoTo(0,0);
GLCD_WriteString("+-------------------+");
GLCD_GoTo(0,1);
GLCD_WriteString("|       Farzad      |");
GLCD_GoTo(0,2);
GLCD_WriteString("|    Ahmadinezhad   |");
GLCD_GoTo(0,3);
GLCD_WriteString("|                   |");
GLCD_GoTo(0,4);
GLCD_WriteString("|   KS0108 Library  |");
GLCD_GoTo(0,5);
GLCD_WriteString("|   For AT91sam7    |");
GLCD_GoTo(0,6);
GLCD_WriteString("|  Microcontrollers |");
GLCD_GoTo(0,7);
GLCD_WriteString("+-------------------+");
delay_s(3) ; 
GLCD_ClearScreen();
for(i=0 ; i<8 ; i++)
  {
   GLCD_GoTo(6*i ,i);
   GLCD_WriteChar(i+48);  
  }   
delay_s(3) ;
GLCD_Rectangle(0, 0, 51, 63);
GLCD_Line(0,9,42,63);
GLCD_Line(6,0,49,54);
GLCD_Circle(96, 32 ,20);
delay_s(3) ;
GLCD_ClearScreen();
while(1){
  for(x=0 ; x<8 ; x++) {
   GLCD_GoTo(6*x ,i);
   GLCD_WriteChar(i+48);
   delay_s(3) ;
   i++;
   }
}
}










