   //                  In The Name Of GOD 
 
 
  /* AT91SAMT7X256 Register definitions */
  #include <AT91SAM7X256.H> 
  /* Delay Functions */
  #define F_CPU 18432000
  #include "delay.h"

  /* Declare LCD Rotation */
  #define PORTRAIT
  /* LCD Pin Configuration */
  #define TFTLCD_DATAPORT_B             
  #define TFTLCD_DATAPORT_OFFSET      0
  #define TFTLCD_CONTROLPORT_B          
  #define TFTLCD_RST                  16
  #define TFTLCD_RS                   18
  #define TFTLCD_CS                   17
  #define TFTLCD_WR                   19
  #define TFTLCD_RD                   20                             
  /* LCD Functions */
  #include "picture.h"
  #include "tftlcd_functions.c"


  int main(void) 
    {			 
	delay_ms(100);
	/* LCD Initialization */
	tftlcd_init();

    #ifdef LANDSCAPE
    tftlcd_write_pic(0,0,picture);
	delay_ms(5000);



	while(1)
		{
		tftlcd_draw_rectangle(0,0,319,239,1,RED);
		delay_ms(1000);
		tftlcd_draw_rectangle(0,0,319,239,1,GREEN);
		delay_ms(1000);
		tftlcd_draw_rectangle(0,0,319,239,1,BLUE);
		delay_ms(1000);
		};
    #endif


    #ifdef PORTRAIT
    tftlcd_write_pic(0,0,picture);
	delay_ms(50000);


	while(1)
		{
		tftlcd_draw_rectangle(0,0,239,319,1,RED);
		delay_ms(1000);
  tftlcd_write_pic(0,0,picture);
	delay_ms(5000);
		};
    #endif

	}
